package com.magnatune.eyecreate.companionformagnatune.api;

import com.magnatune.eyecreate.companionformagnatune.model.AlbumResponse;
import com.magnatune.eyecreate.companionformagnatune.model.xml.Album;
import com.magnatune.eyecreate.companionformagnatune.model.xml.Track;
import com.squareup.okhttp.ResponseBody;
import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.converters.basic.DateConverter;
import com.thoughtworks.xstream.io.xml.Xpp3Driver;

import java.io.IOException;
import java.util.zip.GZIPInputStream;

import retrofit.Converter;

public class MagnatuneAlbumsConverter implements Converter<ResponseBody,AlbumResponse> {
    @Override
    public AlbumResponse convert(ResponseBody value) throws IOException {
        GZIPInputStream compressedStream = new GZIPInputStream(value.byteStream());
        XStream parser = new XStream(new Xpp3Driver());
        parser.processAnnotations(Album.class);
        parser.processAnnotations(Track.class);
        parser.processAnnotations(AlbumResponse.class);
        parser.registerConverter(new DateConverter("yyyy-MM-dd",new String[]{}));
        parser.ignoreUnknownElements();
        AlbumResponse conversion = null;
        try {
            conversion = (AlbumResponse) parser.fromXML(compressedStream);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return conversion;
    }
}
